#!/usr/local/bin/perl
# ↑ご利用のプロバイダが指示したPerlのあるパスを記述してください
#
#!c:/perl/bin/perl
#!/usr/local/bin/perl
#
# ---------------------------------------
# --- My JCC/JCG CGI Ver5.2c ------------
# --- (c)2020 339kasukasuNet ------------
# --- 2021-07-27 ------------------------
# ---------------------------------------
#
#******* 改定履歴 ********
#
# Ver5.2c
# ALL表示では郡を表示させないことにした。
# AJA表示で親市名が表示されてたので修正。
#
# Ver5.2b
# Edgeの最新版ではヘッダー部とデータ表示部に段差が発生することがあるので、
# OFFSET調整できるようにした。(~~;
#
# Ver5.0a
# 1. インラインフレーム構造とした。
# 2. 文字コードをUTF-8に変更した。
#
#「$ENV{'SCRIPT_NAME'}」が妙なPATHを返してくるので
#「function paint(val)」内を以下のように変更してみたら
# //var cgiUrl = document.dispSel.url.value;
#   var cgiUrl = location.href.split('?')[0];
# ----------------
#
# ==================== 管理者が設定する項目です（必須） =======================
# 基本構成(例)
# HomePage_DIR
# |
# |-- myjccjcg (755 または 705)(CGIからアクセス可能な同一ドメイン内のサブディレクトリ)
#   |-- tableData.html (644)(CGIからアクセス可能な同一ドメイン)
# |-- cgi-bin（755 または 705)(プロバイダー指定のCGIディレクトリ)
#   |-- myJccJcg5.cgi  (755 または 705)(本体プログラム)
#   |-- qsoData       (755 または 705)(サブディレクトリ)
#     |-- mcgdata.txt (755 または 705)(QSOデータファイル)
#
#【重要】tableData.html は myJccJcg5.cgi ディレクトリと同一ドメイン内に設置してください。
#
#  ( )内は属性(パーミッッション)です。最初、括弧内の左の数字で試し,
#  動くかどうか確認して下さい。確認がとれたら、３文字の数字の真ん中を0に変更し,
#  動作するかチェックして下さい。どちらでも正常動作できるならば、できるだけ
#  右の方の値を使ってください。
#  (一般にプロバイダにおいては、真ん中の数字を0にすると、セキュリティ的により
#  厳しくなり、他人からファイルを書換えられたりする危険性が減って安全度が上がり
#  ます。ただし中にはCGIが動かなくなるプロバイダもありますので、この場合は
#  左の値をご使用ください）
#
# ==========↓↓ 管理者が設定する項目です（必須） ↓↓===============
$dspTyp			= "X";	# 初期表示選択 "C"だとJCC/JCG "A"だとAJA "T"だと町村 "X"だと全QTH
$COUNTDOWN		= 100;	# カウントダウン残り表示数
$RETURNURL		= "https://www.yahoo.co.jp/";				# 戻るボタンのURL
$TABLEADRS		= "../../radio/myjccjcg/tableData.html";	# tableData.htmlの設置URL
# ---- デバック時用 ----
#$TABLEADRS		= "tableData.html";
#$TEST;
# ---- デバック時用 ----
# ==========↑↑ ここまでが管理者が設定する項目です ↑↑============
#
# ========= ↓↓ カスタマイズする場合は変更してください。↓↓=========
$HTMLTITLE		= "myjccjcg";				# HTMLヘッダーのタイトル
$DATAFILE		= "./qsoData/mcgdata.txt";	# QSOデータファイル
$COOKIE_PREFIX	= "myjccjcg";				# クッキーネーム(Prifix)
$COOKIE_LIFE	= 100;						# クッキー期限（日）
$BKGRNDCOLOR	= "#ccffff";	# ページの背景色
$CALLSGNCOLOR	= "#0000ff";	# コールサインの色
$BRDERCOLOR		= "#555555";	# 表罫線の色
$TABLEBKGRND	= "#ccddff";	# 表の背景色
$TABLEFONT		= "#006600";	# 表の文字色
$HEADBKGRND		= "#ffff00";	# 県ヘッダーの背景色
$HEADFONT		= "#0000ff";	# 県ヘッダーの文字色
$ZNKNURICOLOR	= "#ffaacc";	# 全クリ塗りつぶし色
$NOKORIQTH		= "#663300";	# カウントダウン文字色
$LOCALCHR		= "cp932";		# MicroSoft系Shift_JIS  cp932 shiftjis や euc-jp 
# --- 表のサイズ変更は下記６個のパラメータを相互に調整する必要があり
$FNTSIZE		= "13px";		# 表の文字サイズ
$WIDTH_KEN		= "80px";		# 表Ken幅
$WIDTH_QTH		= "250px";		# 表QTH幅
$WIDTH_DATA		= "40px";		# 表Data幅
$LEFTTABLE		= "18px";		# 表の横位置微調整 18px
$TABLEADJ		= 36;			# 表領域幅 数値を大きくすると表とスクロールバーの隙間が大きくなる。
# ========= ↑↑ カスタマイズする場合は変更してください。↑↑=========
#
#=============== メインプログラム ====
# グローバル変数宣言
$VERSION = "MY JCC/JCG Ver5.2c";
$LOGO	 = "We are the 339kasukasuNet";
$DATE;			# 更新日
@BAND;			# バンドデータ
@MODE;			# モードデータ
$AKIRAME;		# 諦めマーク
@ZENKURI;		# 全クリのバンド範囲
@DISPMENU;		# 表示メニューの選択
$CALL;			# コールサイン
@WKDCMF;		# WKD/CMF
$delSt = "0";	# 0:消滅QTH非表示 1:消滅QTHも表示
$znkSt = "0";	# 0:通常表示 1:全クリ残り表示
$DATAx;			# @WKDCMFのサイズ
$DATAy;			# $#{$WKDCMF[0]}のサイズ;
#=============== 初期化 ====
$CHARSET = "UTF-8";		# 文字コード

loadFormdata();	# フォームデータ取り込み
loadCookie();	# クッキーデータ取り込み
loadData();		# QSOデータの読込み

# クッキー展開
if ($COOKIE{'dspTyp'}) {$dspTyp = $COOKIE{'dspTyp'};}
if ($COOKIE{'delQth'}) {$delSt  = $COOKIE{'delQth'};}
if ($COOKIE{'znkuri'}) {$znkSt  = $COOKIE{'znkuri'};}
if ($COOKIE{'adj'}) {$TABLEADJ  = $COOKIE{'adj'};}


if (exists $FORM{'del'}) {		# 消滅設定
	$delSt = $FORM{'del'};
	&dispPage($dspTyp, $delSt, $znkSt);
}
elsif (exists $FORM{'znk'}) {	# 全クリ設定
	$znkSt = $FORM{'znk'};
	&dispPage($dspTyp, $delSt, $znkSt);
}
elsif (exists $FORM{'dsp'}) {	# 再表示
	$dspTyp = $FORM{'dsp'};
	&dispPage($dspTyp, $delSt, $znkSt);
}elsif (exists $FORM{'cnt'}) {	# カウントダウン
	&printCntdwn();
}
elsif (exists $FORM{'adj'}) {	# テーブル微調
	$TABLEADJ = $FORM{'adj'};
	$COOKIE{'adj'} = $FORM{'adj'};
	&dispPage($dspTyp, $delSt, $znkSt);
}
else {							# テーブル表示
	&dispPage($dspTyp, $delSt, $znkSt);
}
exit(0);


#============= ページ表示 ====
sub dispPage {
	my ($dspSel, $delSel, $znkSel) = @_;
	my $delName, $znkName;
	my $dspC, $dspA, $dspT, $dspX;
	my @nokori;

	@nokori = &makeData("cfm", "norm");	# 表示データの抽出

	if ($delSel eq "0") {	# 消滅ボタンの初期表示を取得
		$delName = "消滅QTHを表示";
	} else {
		$delName = "消滅QTHを消去";
	}

	if ($znkSel eq "0") {	# 全クリボタンの初期表示を取得
		$znkName = "全クリ残り";
	} else {
		$znkName = "通常表示";
	}

	if ($dspSel eq "C") {
		$dspC = "checked = \"checked\"";
	}
	if ($dspSel eq "A") {
		$dspA = "checked = \"checked\"";
	}
	if ($dspSel eq "T") {
		$dspT = "checked = \"checked\"";
	}
	if ($dspSel eq "X") {
		$dspX = "checked = \"checked\"";
	}

	$COOKIE{'dspTyp'} = $dspSel;	# 表示設定をクッキーへ
	$COOKIE{'delQth'} = $delSel;
	$COOKIE{'znkuri'} = $znkSel;

	printHttpHeader();
	
	print <<END;
<!DOCTYPE html>
<html lang="ja">
<head> 
<meta charset="utf-8">
<title>myjccjcg</title>
<style type="text/css">
<!--
body {
	font-family:'メイリオ', 'Hiragino Kaku Gothic Pro', sans-serif;
	background-color:$BKGRNDCOLOR;
	color:black;
	margin-top:0px;
	margin-bottom:0px;
}

p {
	margin-top:0px;
	margin-bottom:0px;
}

#call {
	margin-top:0px;
	margin-bottom:0px;
	font-family:'Franklin Gothic Medium','arial black';
	font-size:35px;
	text-align:center;
	color:$CALLSGNCOLOR;
	padding:0px;
}

#select	{
	margin-top:0px;
	margin-bottom:2px;
	font-size:$FNTSIZE;
	text-align:center;
	padding:0px;
}

#adjTable {
	margin-top:0px;
	margin-bottom:2px;
	font-size:$FNTSIZE;
	text-align:center;
	padding:0px;
}

#info {
	margin-top:0px;
	margin-bottom:0px;
	color:black;
	font-size:$FNTSIZE;
	text-align:center;
	padding:0px;
}

table.table {	/* テーブル全体 */
	border-spacing:0px;
	border-bottom:2px solid $BRDERCOLOR;
	text-align:center;
	margin-left:AUTO;
	margin-right:AUTO;
}

td.logo {	/* ロゴ */
	color:black;
	font-size:12px;
	text-align:right;
	border-bottom:2px solid $BRDERCOLOR;
	padding:0px 5px 5px 0px;
}

tr.bandMode {	/* No, QTH, Freq, Mode */
	color:$HEADFONT;
	font-size:$FNTSIZE;
	font-weight:bold;
	background-color:$HEADBKGRND;
}

th.bandMode1 {	/* No */
	width:$WIDTH_KEN;
	border-left:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

th.bandMode2 {	/* QTH */
	width:$WIDTH_QTH;
	border-left:2px solid $BRDERCOLOR;
	border-right:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

td.band {	/* Freq */
	color:$HEADFONT;
	font-size:$FNTSIZE;
	font-weight:bold;
	background-color:$HEADBKGRND;
	width:$WIDTH_DATA;
	border-right:2px solid $BRDERCOLOR;
	border-bottom:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

td.mode {	/* Mode */
	color:$HEADFONT;
	font-size:$FNTSIZE;
	font-weight:bold;
	background-color:$HEADBKGRND;
	border-right:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

td.nokoriH {	/* バンド残り */
	color:$TABLEFONT;
	font-size:$FNTSIZE;
	background-color:$HEADBKGRND;
	border-top:2px solid $BRDERCOLOR;
	border-left:2px solid $BRDERCOLOR;
	border-right:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

td.nokoriD1 {	/* Wkd/Cfmが "-" */
	color:$TABLEFONT;
	font-size:$FNTSIZE;
	background-color:$HEADBKGRND;
	border-top:2px solid $BRDERCOLOR;
	border-right:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

td.nokoriD2 {	/* Wkd/Cfmが "完" */
	color:$TABLEFONT;
	font-size:$FNTSIZE;
	background-color:$ZNKNURICOLOR;
	border-top:2px solid $BRDERCOLOR;
	border-right:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

td.nokoriD3 {	/* Wkd/Cfmが "残り数" */
	color:$TABLEFONT;
	font-size:$FNTSIZE;
	background-color:$TABLEBKGRND;
	border-top:2px solid $BRDERCOLOR;
	border-right:2px solid $BRDERCOLOR;
	padding:0px 0px 0px 0px;
}

#inLine {	/* IFRAME自体 */
	text-align:center;
 }

iframe {	/* 疑似シームレス */
	border: none;
}


//-->
</style>
<script type = "text/javascript">
<!--

//# 戻る
function rtnHome() {
	location = "$RETURNURL";
}


//# ジャンプ
function kenSelect(val) {
	var kenNo = val;

	//# ジャンプ先のリンクを定義
	var iJump = document.getElementById("iframePage");
	var jumpDoc = iJump.contentDocument;
	var jumpAdd = jumpDoc.getElementById("kenNo");
	jumpAdd.innerHTML = "<a href='#" + kenNo + "'></a>";

	//# リンクスポットをクリック
	var iframe = document.getElementById("iframePage");
	iframe.contentWindow.jump();
}


//# 表示モード選択
function paint(val) {
	var btnName = val;
	var delSt;
	var znkSt;
	var chked;
	var dspTyp;
	var sendMsg;
	var cgiUrl = document.dispSel.url.value;

	if (btnName == "botn1") {	//# 消滅選択
		if(document.dispSel.botn1.value == "消滅QTHを表示") {
			document.dispSel.botn1.value = "消滅QTHを消去";
			delSt = "1";		//# 消滅を表示
		} else {
			document.dispSel.botn1.value = "消滅QTHを表示";
			delSt = "0";		//# 消滅を消去
		}
		sendMsg = "?del=" + delSt;
	}

	if (btnName == "botn2") {	//# 全クリ選択
		if(document.dispSel.botn2.value == "全クリ残り") {
			document.dispSel.botn2.value = "通常表示";
			znkSt = "1";		//# 全クリを表示
		} else {
			document.dispSel.botn2.value = "全クリ残り";
			znkSt = "0";		//# 通常表示
		}
		sendMsg = "?znk=" + znkSt;
	}

	if (btnName == "botn3") {	//# カウントダウン
		sendMsg = "?cnt";
	}

	if (btnName == "rdt1") {	//# 表示タイプ JCC/AJA/町村/ALL
		chked = document.getElementsByName("rdt1");
		for(i = 0; i < chked.length; i++) {
			if (chked[i].checked) {
				dspTyp = chked[i].value;
			}
		}
		sendMsg = "?dsp=" + dspTyp;
	}

	location = cgiUrl + sendMsg;	//# CGIスクリプトの呼び出し
}


//# インラインフレーム構築
function iframeTable() {
	//# モバイル端末だったら残りヘッダーは表示させない
	if ((navigator.userAgent.indexOf("iPhone") > 0) || (navigator.userAgent.indexOf("Android") > 0)) {
		var nokoriH = document.getElementById("nokoriHead");
		nokoriH.innerHTML = "<p> </p>";
	}
END

	my ($ken0, $ken1, $ken2, $ken3, $znkCnt, $znkFlg, $i, $j, $k, $size);
	my $massege = "<table class = 'table' table-layout:fixed>";
	
	$ken0 = 0;
	$size = @WKDCMF;

	for ($i = 0; $size > $i; ++$i) {
		# 県ヘッダー
		$ken1 = substr ($WKDCMF[$i][1], 0, 2);	# CODE先頭から2桁抽出 ex "01"
		$Ken2 = $ken1 + 0;						# 変数型変換

		if ($Ken2 > $ken0) {					# 次県になったらヘッダーを挿入
			$ken0 = $Ken2;
			$ken3 = "0".$ken0;					# 県番号先頭に "0" を付加し 01, 011..
			$ken3 = substr ($ken3, -2, 2);		# 末尾から２ケタを抽出 01,11..
			$massege = $massege.&makeHeader3($ken3);
		}

		# 全クリ塗りつぶし
		if ($ZENKURI[0] ne "---" and $ZENKURI[1] ne "---") {
			$znkFlg = "no";
			$znkCnt = 0;
			for ($k = $ZENKURI[0] + 2; $k <= $ZENKURI[1] + 2; ++$k) {
				if ($WKDCMF[$i][$k] eq "C") { ++$znkCnt; }
			}
			if ($znkCnt == $ZENKURI[1] - $ZENKURI[0] + 1) {
				$znkFlg = "yes";
			}
		}

		$massege = $massege."<tr>";
		for ($j = 0; $#{$WKDCMF[0]} > $j; ++$j) {
			if ($j < 2) {	# CODEとQTH
				$massege = $massege."<td class = 'codeQth'>$WKDCMF[$i][$j+1]</td>";
			} else {		# WKD/CFM
				if ($znkFlg eq "yes" and $ZENKURI[0] < $j and $ZENKURI[1] > $j - 2) {	# 全クリ
					$massege = $massege."<td class = 'dataZNK'>$WKDCMF[$i][$j+1]</td>";
				}
				elsif ($WKDCMF[$i][$j+1] eq " ") {	# 空データだと罫線が消えるので"_"を背景色で出力
					$massege = $massege."<td class = 'data_'>_</td>";
				}
				else {
					$massege = $massege."<td class = 'dataNorm'>$WKDCMF[$i][$j+1]</td>";
				}
			}
		}
		$massege = $massege."</tr>";
	}
	$massege = $massege."</table>";
	print "writeIframe('p001',\"$massege\");";

# ---- メンテナンス用 -----
#	print "writeIframe('p001',\"$massege\" + \"$ken2\");";
# ---- メンテナンス用 -----

	print <<END;
}


//# インラインフレームの書き出し
function writeIframe(val1,val2) {
	var id = val1;
	var massage = val2;
	var iframe1 = document.getElementById("iframePage");
	var items1 = iframe1.contentDocument;
	var divice1 = items1.getElementById(id);
	divice1.innerHTML = massage;
}


//# インラインフレームのサイズ調整
function changeSize(val) {
	var frm = val;
	var heightSize = window.innerHeight;
	var docFrame = document.getElementById(frm);
END

	my $tableWidth = 2 + 82 + 252 + (@BAND * 42) + $TABLEADJ;	# td幅　border 2pxを含む　$TABLEADJはスクロールバー
	print <<END;

	docFrame.width = $tableWidth;
	docFrame.height = heightSize - 220;	//# 画面高さ - DISPメニュー

	setColor();	//# CSS設定
}


//# tableData.htmlのCSS設定
function setColor() {
	var iframe = document.getElementById("iframePage");
	var clrDoc = iframe.contentDocument;
	var css = clrDoc.styleSheets;

	var styleSheet = css[0];
	var rules = styleSheet.rules || styleSheet.cssRules;
	var x = "2px solid ";

	rules[1].style.fontSize = "$FNTSIZE";				//# table.table
	rules[1].style.marginLeft = "$LEFTTABLE";
	rules[1].style.borderLeft = x + "$BRDERCOLOR";
	rules[2].style.color = "$HEADFONT";					//# tr.bandMode
	rules[2].style.backgroundColor = "$HEADBKGRND";
	rules[3].style.width = "$WIDTH_KEN";				//# th.bandMode1
	rules[3].style.borderRight = x + "$BRDERCOLOR";
	rules[3].style.borderBottom = x + "$BRDERCOLOR";
	rules[4].style.width = "$WIDTH_QTH";				//# th.bandMode2
	rules[4].style.borderRight = x + "$BRDERCOLOR";
	rules[4].style.borderBottom = x + "$BRDERCOLOR";
	rules[5].style.width = "$WIDTH_DATA";				//# td.band
	rules[5].style.borderRight = x + "$BRDERCOLOR";
	rules[5].style.borderBottom = x + "$BRDERCOLOR";
	rules[6].style.borderRight = x + "$BRDERCOLOR";		//# td.mode
	rules[6].style.borderBottom = x + "$BRDERCOLOR";
	rules[7].style.color = "$TABLEFONT";				//# td.codeQth
	rules[7].style.backgroundColor = "$TABLEBKGRND";
	rules[7].style.borderRight = x + "$BRDERCOLOR";
	rules[7].style.borderBottom = x + "$BRDERCOLOR";
	rules[8].style.color = "$TABLEFONT";				//# td.dataZNK
	rules[8].style.backgroundColor = "$ZNKNURICOLOR";
	rules[8].style.borderRight = x + "$BRDERCOLOR";
	rules[8].style.borderBottom = x + "$BRDERCOLOR";
	rules[9].style.color = "$TABLEBKGRND";				//# td.data_
	rules[9].style.backgroundColor = "$TABLEBKGRND";
	rules[9].style.borderRight = x + "$BRDERCOLOR";
	rules[9].style.borderBottom = x + "$BRDERCOLOR";
	rules[10].style.color = "$TABLEFONT";				//# td.dataNorm
	rules[10].style.backgroundColor = "$TABLEBKGRND";
	rules[10].style.borderRight = x + "$BRDERCOLOR";
	rules[10].style.borderBottom = x + "$BRDERCOLOR";
}


//-->
</script>
</head>
<body onload = "iframeTable()">
<div id = "call">$CALL</div>
<div id = "select">
	<form name = "dispSel">
		<select name = "select1" onChange = "kenSelect(this[this.selectedIndex].value)">
			<option value = "01">01 北海道
			<option value = "02">02 青森
			<option value = "03">03 岩手
			<option value = "04">04 秋田
			<option value = "05">05 山形
			<option value = "06">06 宮城
			<option value = "07">07 福島
			<option value = "08">08 新潟
			<option value = "09">09 長野
			<option value = "10">10 東京
			<option value = "11">11 神奈川
			<option value = "12">12 千葉
			<option value = "13">13 埼玉
			<option value = "14">14 茨城
			<option value = "15">15 栃木
			<option value = "16">16 群馬
			<option value = "17">17 山梨
			<option value = "18">18 静岡
			<option value = "19">19 岐阜
			<option value = "20">20 愛知
			<option value = "21">21 三重
			<option value = "22">22 京都
			<option value = "23">23 滋賀
			<option value = "24">24 奈良
			<option value = "25">25 大阪
			<option value = "26">26 和歌山
			<option value = "27">27 兵庫
			<option value = "28">28 富山
			<option value = "29">29 福井
			<option value = "30">30 石川
			<option value = "31">31 岡山
			<option value = "32">32 島根
			<option value = "33">33 山口
			<option value = "34">34 鳥取
			<option value = "35">35 広島
			<option value = "36">36 香川
			<option value = "37">37 徳島
			<option value = "38">38 愛媛
			<option value = "39">39 高知
			<option value = "40">40 福岡
			<option value = "41">41 佐賀
			<option value = "42">42 長崎
			<option value = "43">43 熊本
			<option value = "44">44 大分
			<option value = "45">45 宮崎
			<option value = "46">46 鹿児島
			<option value = "47">47 沖縄
		</select>

		<input type = "button" name = "botn1" value = "$delName" onClick = "paint(this.name)">
		<input type = "button" name = "botn2" value = "$znkName" onClick = "paint(this.name)">
		<input type = "button" name = "botn3" value = "カウントダウン $COUNTDOWN" onClick = "paint(this.name)">
		<input type = "radio" name = "rdt1" value = "C" onClick = "paint(this.name)" $dspC>JCC/JCG
		<input type = "radio" name = "rdt1" value = "A" onClick = "paint(this.name)" $dspA>AJA
		<input type = "radio" name = "rdt1" value = "T" onClick = "paint(this.name)" $dspT>町村
		<input type = "radio" name = "rdt1" value = "X" onClick = "paint(this.name)" $dspX>ALL　

		<input type = "button" name = "botn4" value = "戻る" onClick = "rtnHome()">

		<!-- hidden はJava Script にデータ転送 -->
		<input type = "hidden" name = "url"    value = "$ENV{'SCRIPT_NAME'}">
		<input type = "hidden" name = "ckiPfx" value = "$COOKIE_PREFIX">
	</form>
</div>
<!--# コメント表示-->
<div id = "info">
	<p>
		&nbsp;
		$DATE&nbsp&nbsp&nbsp
		C(その他)：CFM&nbsp&nbsp&nbsp
		W：WKD&nbsp&nbsp&nbsp
		?：焦げ付き&nbsp&nbsp&nbsp
		$AKIRAME：あきらめ&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
		$VERSION
	</p>

	<div id = "adjTable">
		<form action="$ENV{'SCRIPT_NAME'}" method="POST">
				表の固定部と可動部に段差ができたら 
			<input type = "text" name = "adj" size = "2" value = $TABLEADJ>
				OFFSETを調整してください。
			<input type = "submit" value = "変更">
				　または、画面の拡大縮小を100%にしてください。
		</form>
	</div>
</div>

<div id = "nokoriHead">
	<!--# 残りテーブルヘッダー -->
	<table class = "table">
		<tr>
			<td class = "logo"colspan = "99">$LOGO</td>
		</tr>
END
			my @nokori;
			@nokori = &makeData("cfm", "norm");	# 残り算出のため

			&makeHeader("No");		# バンドモードヘッダー(固定部)
			&nokoriValue(@nokori);	# 残りヘッダー

		print <<END;
	</table>
</div>

<!--# インラインフレームを構築 -->
<div id = "inLine">
	<iframe sandbox = "allow-scripts allow-same-origin" id = "iframePage" src  = "$TABLEADRS" onLoad = "changeSize(this.id)"></iframe>
</div>
</body>
</html>
END

}


#============= カウントダウン ====
sub printCntdwn {
	my (@nokoriQth, @nokori, $i, $j, $k, $m, $max, $cntAri);

	@nokori    = &makeData("cfm", "count");	# 残りリスト
	@nokoriQth = &makeData("nokori");		#           の取得

	for ($i = 0; @nokoriQth > $i; ++$i) {
		if ($#{$nokoriQth[$i]} > $max and $#{$nokoriQth[$i]} <= $COUNTDOWN) {
			$max = $#{$nokoriQth[$i]};	# 残りバンド最大QTH数
		}
	}
	++$max;	# 配列の要素数に+1したものが配列数

	printHttpHeader();

	print <<END;
<!DOCTYPE html>
<html lang="ja">
<head> 
<meta charset="utf-8">
<title>countdwn</title>
<style type="text/css">
<!--
body {
	font-family:'メイリオ', 'Hiragino Kaku Gothic Pro', sans-serif;
	background-color:$BKGRNDCOLOR;
	color:$TABLEFONT;
	font-size:$FNTSIZE;
	margin-top:0px;
	margin-bottom:0px;
	text-align:center;
}

table.table {	/* テーブル全体 */
	border-spacing:0px;
	border-top:2px solid $BRDERCOLOR;
	border-bottom:2px solid $BRDERCOLOR;
	border-left:2px solid $BRDERCOLOR;
	text-align:center;
	margin-left:AUTO;
	margin-right:AUTO;
}

td.band {	/* Freq */
	color:$HEADFONT;
	font-size:$FNTSIZE;
	font-weight:bold;
	background-color:$HEADBKGRND;
	border-right:2px solid $BRDERCOLOR;
	border-bottom:2px solid $BRDERCOLOR;
	padding:5px;
}

td.data {	/* Freq */
	color:$NOKORIQTH;
	text-align:left;
	font-size:$FNTSIZE;
	border-right:2px solid $BRDERCOLOR;
	padding:5px 20px 5px 0px;
}

//-->
</style>

<script type = "text/javascript">
<!--

//# 戻る
function rtnJccjcg() {
	var cgiUrl = document.dispSel.url.value;
	location = cgiUrl;
}

//-->
</script>
</head>

<body>
<p>
<form name = "dispSel">
	未CFM QTHリスト&nbsp;&nbsp;(WKDだけのQTHも含む)&nbsp;&nbsp;&nbsp;
	<input type = "button" name = "botn1" value = "戻る" onClick = "rtnJccjcg()">
	<input type = "hidden" name = "url"   value = "$ENV{'SCRIPT_NAME'}">
</form>
</p>
END

	print "<table class = 'table'><tr>";
	for ($i = 0; @nokori >= $i; ++$i) {
		if ($nokori[$i] <= $COUNTDOWN and $nokori[$i] > 0) {	# 0以上CNTDWN以下
			print "<td class = 'band'>@BAND[$i] $MODE[$i]</td>";
		}
	}
	print "</tr><tr>";
	for ($i = 0; @nokori >= $i; ++$i) {
		$k = 0;
		if ($nokori[$i] <= $COUNTDOWN and $nokori[$i] > 0) {
			print "<td class = 'data'>";
			for ($j = 0; $max > $j; ++$j) {
				++$k;
				$m = 3 -length ($k);	# 左側余白
				if ($nokoriQth[$i][$j] ne "") {
					for ($n = 0; $m > $n; ++$n) {
						print "&nbsp;";
					}
					print "$k：";
					print "$nokoriQth[$i][$j]";
					print "&nbsp;&nbsp;<br>\n";
				}
				else {
					print "<br>";
				}
			}
			$cntAri = "yes";	# カウントダウンデータあり
		}
		print "</td>";
	}
	print "</tr></table>";

	if (!$cntAri) {		# カウントダウンデータがないので
		print "<p>カウントダウンに該当するデータがなし。</p>";
	}
	print <<END;
</div></body></html>
END

}


#============= テーブルヘッダー ====
sub makeHeader() {
	my $ken1 = @_[0];

	print <<END;
	<tr class = "bandMode">
	<th class = "bandMode1" rowspan = "2">$ken1</th>
	<th class = "bandMode2" rowspan = "2">QTH</th>
END

	# ヘッダー部の書き出し
	my $i;
	foreach my $bandx (@BAND) {		# バンドの書き出し
		++$i;
		print "<td class = \"band\">$bandx</td>";
	}
	print "</tr>\n<tr class = \"bandMode\">";

	foreach my $modex (@MODE) {		# モードの書き出し
		print "<td class = \"mode\">$modex</td>";
	}
	print "</tr>\n";
}


#============= テーブルヘッダー ====
sub makeHeader3() {
	my $ken1 = @_[0];
	my $massege;

	$massege = "<tr class = 'bandMode'><th class = 'bandMode1' rowspan = '2'>$ken1</th><th class = 'bandMode2' rowspan = '2'>QTH</th>";

	# ヘッダー部の書き出し
	my $i;
	foreach my $bandx (@BAND) {		# バンドの書き出し
		++$i;
		if ($i == 1) {				# アンカーを最初のバンドに設定
			$massege = $massege."<td class = 'band'><a name = '$ken1'>$bandx</a></td>";
		} else {
			$massege = $massege."<td class = 'band'>$bandx</td>";
		}
	}
	$massege = $massege."</tr><tr class = 'bandMode'>";

	foreach my $modex (@MODE) {		# モードの書き出し
		$massege = $massege."<td class = 'mode'>$modex</td>";
	}
	$massege = $massege."</tr>";

	return ($massege);
}


#============= 残り表示 ====
sub nokoriValue {
	my @nokori = @_;

	print <<END;
	<tr>
	<td class = "nokoriH" colspan = "2" >バンド残り</td>
END

	my $i;
	my $j = @nokori;
	my $k;
	
	if ($j == 0) {
		$k = $DATAy - 2;
	} else {
		$k = $j;
	}

	for ($i = 0; $k > $i; ++$i) {
		# 全クリ表示に全クリバンド対象外は"-"表示にする
		if (($znkSt eq "1" and $ZENKURI[0] > $i + 1) or ($znkSt eq "1" and $ZENKURI[1] < $i + 1)) {
			print "<td class = \"nokoriD1\">-</td>";
		} else {
			if ($nokori[$i] == 0) {		# 残りが 0 なら完了表示
				print "<td class = \"nokoriD2\">完</td>";
			} else {
				print "<td class = \"nokoriD3\">$nokori[$i]</td>";
			}
		}
	}
	print "</tr>\n";
}


#============= 表示データの抽出 ====
sub makeData {
	my $work1 = $_[0];
	my $work2 = $_[1];
	my ($delCnt, $kuri, $nokoQth, @nokori, @nokoriQth);
	my ($i, $j);

	# 消滅QTHの処理
	if ($delSt eq "0") {	# 0:消滅QTH非表示 1:消滅QTHも表示
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			if ($WKDCMF[$i][2] =~ m/[0-9]/) {
				splice (@WKDCMF,$i,1);
				--$i;
			}
		}
	}

	# 全クリ残り表示
	if ($znkSt eq "1" and $work2 eq "norm") {	# 0:通常表示 1:全クリ残り表示
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			$delCnt = 0;
			for ($j = $ZENKURI[0]; $ZENKURI[1] >= $j; ++$j) {
				if ($WKDCMF[$i][2+$j] eq "C") {
					++$delCnt;			# Cのバンド数をカウント
				}
			}
			if ($delCnt == $ZENKURI[1] - $ZENKURI[0] + 1) {
				splice (@WKDCMF,$i,1);	# Cの数が全クリバンド範囲と一致したら
				--$i;
			}
		}
	}

	# 表示タイプの処理 ALL
	if ($dspTyp eq "X") {	# X:ALL
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			if (($WKDCMF[$i][0] eq "G")) {
				splice (@WKDCMF,$i,1);
				--$i;
			}

			# 政令都市を削除
			$i = &bigCity($i);
		}
	}

	# 表示タイプの処理 JCC/JCG
	if ($dspTyp eq "C") {	# C:JCC/JCG
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			if (($WKDCMF[$i][0] eq "A") or ($WKDCMF[$i][0] eq "T")) {
				splice (@WKDCMF,$i,1);
				--$i;
			}
		}
	}

	# 表示タイプの処理 AJA
	if ($dspTyp eq "A") {	# A:AJA
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			if ($WKDCMF[$i][0] eq "T") {
				splice (@WKDCMF,$i,1);
				--$i;
			}

			# 政令都市を削除
			$i = &bigCity($i);
		}
	}

	# 表示タイプの処理 町村
	if ($dspTyp eq "T") {	# T:町村
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			if ($WKDCMF[$i][0] ne "T") {
				splice (@WKDCMF,$i,1);
				--$i;
			}
		}
	}

	# 残りQTHの集計
	for ($j = 3; @{$WKDCMF[0]} > $j; ++$j) {
		$kuri = 0;
		$nokoQth = 0;
		for ($i = 0; $#WKDCMF + 1 > $i; ++$i) {
			if ($WKDCMF[$i][$j] eq "C") {
				++$kuri;
			} else {
				if ($WKDCMF[$i][$j] eq " ") {	# 残りQTHリスト
					$nokoriQth[$j - 3][$nokoQth] = $WKDCMF[$i][2];	# No WKD
				} else {
					$nokoriQth[$j - 3][$nokoQth] = "<font color=\"blue\">".$WKDCMF[$i][2]." [ WKD ]</font>";	# WKDしている
				}
				++$nokoQth;
			}
		}
		$nokori[$j - 3] = $#WKDCMF + 1 - $kuri; 	# バンド毎の残り数
	}

	if ($work1 eq "cfm") {
		return (@nokori);		# WKD/CFM表へ
	} else {
		return (@nokoriQth);	# カウントダウンへ
	}
}


#============= 政令指定都市 ====
sub bigCity {
	my $i = $_[0];

	if ($WKDCMF[$i][0] eq "A") {
		$pos1 = index ($WKDCMF[$i][2],"市", 0);
		$city = substr ($WKDCMF[$i][2], 0, $pos1 + 2);	# 種別Aから市名を取得
		if (index ($WKDCMF[$i-1][2], $city, 0) > -1 && ($WKDCMF[$i-1][0] eq "C")) {	# 1個前のデータの市名が同じで
			splice (@WKDCMF,$i-1,1);												# かつ種別Cだったら削除
			--$i;
		}
	}
	return $i;
}


#============= QSOデータの読込み ====
sub loadData {
	my ($i, @qsoData, $dmy, @DATA);

	open (FILE, "<$DATAFILE") or printErrorPage("QSOデータファイルが開けません。");
	flock (FILE, 1);
	@DATA = <FILE>;
	close (FILE);

	@qsoData = @DATA;	# 処理用配列にコピー

	# 更新日の抽出
	($dmy, $DATE) = split (/,/, $qsoData[0]);
	$DATE =~ s/[\r\n]+$//;			# デリミタの処理

	# Bandデータの抽出
	while ($qsoData[1] =~ /,/ ) {	# カンマ区切りで抜き取り
		$BAND[$i] = $`;				# カンマより前半部分
		$BAND[$i] =~ s/[\r\n]+$//;	# デリミタの処理
		$qsoData[1] = $';			# カンマより後半部分
		++$i;
	}
	$BAND[$i] = $qsoData[1];		# 最後尾部分
	$BAND[$i] =~ s/[\r\n]+$//;
	splice (@BAND,0,1);				# 先頭の空データを削除
	pop @BAND;						# 末尾の空データを削除

	# Modeデータの抽出
	$i = 0;
	while ($qsoData[2] =~ /,/ ) {
		$MODE[$i] = $`;
		$MODE[$i] =~ s/[\r\n]+$//;
		$qsoData[2] = $';
		++$i;
	}
	$MODE[$i] = $qsoData[2];
	$MODE[$i] =~ s/[\r\n]+$//;
	splice (@MODE,0,1);
	pop @MODE;
	for ($i = 0; @MODE > $i; ++$i) {
		if ($MODE[$i] eq "XXX") { $MODE[$i] = "-"; }
	}

	# 諦めマークの抽出
	($dmy, $AKIRAME) = split (/,/, $qsoData[3]);
	$AKIRAME =~ s/[\r\n]+$//;

	# 全クリバンド範囲の抽出
	$i = 0;
	while ($qsoData[4] =~ /,/ ) {
		$ZENKURI[$i] = $`;
		$ZENKURI[$i] =~ s/[\r\n]+$//;
		$qsoData[4] = $';
		++$i;
	}
	splice (@ZENKURI,0,1);
	if ($ZENKURI[0] > $ZENKURI[1]) {	# 全クリバンドの大小が反転していたら
		($ZENKURI[0],$ZENKURI[1]) = ($ZENKURI[1],$ZENKURI[0]);
	}

	# 表示タイプの抽出
	$i = 0;
	while ($qsoData[5] =~ /,/ ) {
		$DISPMENU[$i] = $`;
		$DISPMENU[$i] =~ s/[\r\n]+$//;
		$qsoData[5] = $';
		++$i;
	}
	splice (@DISPMENU,0,1);

	# コールサインの抽出
	($dmy, $CALL) = split (/,/, $qsoData[6]);
	$CALL =~ s/[\r\n]+$//;

	# WKD/CMFの抽出
	use Encode;				# MASTERファイルはSJISのためUTF-8に変換
	splice (@qsoData,0,7);	# WKD/CFM以外のデータを削除
	for ($i = 0; @qsoData > $i; ++$i) {
		$j = 0;
		$qsoData[$i] = substr ($qsoData[$i], 1);	# 先頭のカンマを削除
		while ($qsoData[$i] =~ /,/ ) {
			$WKDCMF[$i][$j] = $`;
			$WKDCMF[$i][$j] =~ s/[\r\n]+$//;
			
			if ($j == 2) {	# QTHは日本語なので文字コード変換
				$WKDCMF[$i][$j] = decode($LOCALCHR,$WKDCMF[$i][$j]);	# cp932はMSがShift_JISを独自に拡張した文字コード
			}
			
			$qsoData[$i] = $';
			++$j;
		}
		$WKDCMF[$i][$j] = $qsoData[$i];
		$WKDCMF[$i][$j] =~ s/[\r\n]+$//;	# 配列構造 WKDCMF[QTH縦][BAND横]
	}
	$DATAx = @WKDCMF;
	$DATAy = $#{$WKDCMF[0]};
}


#======================== エラーページ出力 ====
sub printErrorPage {
	print <<END;
Content-type: text/html; charset=$CHARSET

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head><title>error</title></head>
<body><h1>エラー</h1><p>$_[0]</p></body>
</html>
END
	exit(0);
}


#======================== HTTPヘッダー出力 ====
sub printHttpHeader {
	# グリニッジ標準時の文字列
	my @mon_str = (
		'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
		'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	my @wdy_str = (
		'Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
	my ($sec, $min, $hour, $mday, $mon, $year, $wday)
		= gmtime(time + ($COOKIE_LIFE * 24 * 60 * 60));
	my $date = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
		$wdy_str[$wday], $mday, $mon_str[$mon], $year + 1900,
		$hour, $min, $sec);
	
	# ヘッダーの出力
	my ($name, $value);
	
	print "Content-type: text/html; charset=$CHARSET\n";
	foreach $name (keys %COOKIE) {
		$value = $COOKIE{$name};
		$name = "${COOKIE_PREFIX}_$name";
		$value =~ s/(\W)/sprintf("%%%02X", ord($1))/eg;
		
		print "Set-Cookie: $name=$value; expires=$date\n";
	}
	print "\n";
}


#================== クッキーデータ取り込み ====
sub loadCookie {
	my $pair;
	
	foreach $pair (split(/;\s*/, $ENV{'HTTP_COOKIE'})) {
		my ($name, $value) = split(/=/, $pair);
		
		if (not $name =~ /${COOKIE_PREFIX}_(.+)/) {
			next;
		}
		
		$name = $1;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		$COOKIE{$name} = $value;
	}
}


#================== フォームデータ取り込み ====
sub loadFormdata {
	my ($query, $pair, $key, $value);

	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
	}
	else {
		$query = $ENV{'QUERY_STRING'};
	}
	
	foreach $pair (split(/&/, $query)) {
		($key, $value) = split(/=/, $pair);
		
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		$value =~ s/&/&amp;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ tr/\t/ /;
		
		$FORM{$key} = $value;
	}
}


